blob: 15ac76658a0bd4cc32b9f0ba50ee0d6176540e5f [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Thomas Heijligenf579bba2021-10-12 12:48:01 +020031STRIP_ARGS = -s
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000032INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000033DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000034PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000035MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010036CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000037EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000038RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000039PKG_CONFIG ?= pkg-config
40BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000041
Stefan Taunerfd0d4132012-09-25 21:24:55 +000042# The following parameter changes the default programmer that will be used if there is no -p/--programmer
43# argument given when running flashrom. The predefined setting does not enable any default so that every
44# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
45# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
46# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
47# system attached to an external programmer while the default programmer is set to the internal programmer, and
48# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
49# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
51CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000052# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020053CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000054# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020055# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000056# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000057
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000058# If your compiler spits out excessive warnings, run make WARNERROR=no
59# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000060WARNERROR ?= yes
61
62ifeq ($(WARNERROR), yes)
63CFLAGS += -Werror
64endif
65
Stefan Taunere37735a2015-01-26 22:03:35 +000066ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000067PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000068override CPPFLAGS += -I$(LIBS_BASE)/include
69override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000070endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000071
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000073override PKG_CONFIG += --static
74override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075endif
76
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077# Set LC_ALL=C to minimize influences of the locale.
78# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060079# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080LC_ALL=C
81export LC_ALL
82
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000083dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000084
85# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
86# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090087debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
88 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000089
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000090###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020091# Dependency handling.
92
93DEPENDS_ON_SERIAL := \
94 CONFIG_BUSPIRATE_SPI \
95 CONFIG_PONY_SPI \
96 CONFIG_SERPROG \
97
98DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020099 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200100 CONFIG_INTERNAL \
101 CONFIG_NICINTEL_SPI \
102 CONFIG_OGP_SPI \
103 CONFIG_PONY_SPI \
104 CONFIG_RAYER_SPI \
105
106DEPENDS_ON_LIBPCI := \
107 CONFIG_ATAHPT \
108 CONFIG_ATAPROMISE \
109 CONFIG_ATAVIA \
110 CONFIG_DRKAISER \
111 CONFIG_GFXNVIDIA \
112 CONFIG_INTERNAL \
113 CONFIG_IT8212 \
114 CONFIG_NIC3COM \
115 CONFIG_NICINTEL \
116 CONFIG_NICINTEL_EEPROM \
117 CONFIG_NICINTEL_SPI \
118 CONFIG_NICNATSEMI \
119 CONFIG_NICREALTEK \
120 CONFIG_OGP_SPI \
121 CONFIG_SATAMV \
122 CONFIG_SATASII \
123
124DEPENDS_ON_LIBUSB1 := \
125 CONFIG_CH341A_SPI \
126 CONFIG_DEDIPROG \
127 CONFIG_DEVELOPERBOX_SPI \
128 CONFIG_DIGILENT_SPI \
129 CONFIG_PICKIT2_SPI \
130 CONFIG_RAIDEN_DEBUG_SPI \
131 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200132 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200133
134DEPENDS_ON_LIBFTDI := \
135 CONFIG_FT2232_SPI \
136 CONFIG_USBBLASTER_SPI \
137
138DEPENDS_ON_LIBJAYLINK := \
139 CONFIG_JLINK_SPI \
140
Nico Hubera54f5a42021-06-27 14:27:41 +0200141
142ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
143$(call disable_all,$(DEPENDS_ON_LIBUSB1))
144endif
145
146ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
147$(call disable_all,$(DEPENDS_ON_LIBPCI))
148endif
149
Nico Huber7f898972021-06-27 13:30:50 +0200150###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000151# General OS-specific settings.
152# 1. Prepare for later by gathering information about host and target OS
153# 2. Set compiler flags and parameters according to OSes
154# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000155
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000156# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000157HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100158ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000159# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
160CC = gcc
161endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100162
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000163# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000164# IMPORTANT: The following line must be placed before TARGET_OS is ever used
165# (of course), but should come after any lines setting CC because the line
166# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900167override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
168 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000169
Thomas Heijligen0bec7b22021-10-12 13:18:15 +0200170ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD OpenBSD DragonFlyBSD))
171override CPPFLAGS += -I/usr/local/include
172override LDFLAGS += -L/usr/local/lib
173endif
174
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000175ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000176override CPPFLAGS += -I/opt/local/include -I/usr/local/include
177override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000178endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000179
Stefan Taunerc65b8552013-09-12 15:48:39 +0000180ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000181# Needs special `pciutils/pci.h` for older NetBSD packages
182PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
183override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000184override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000185endif
186
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000187ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000188EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000189# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000190override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000191LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200192# Missing serial support.
193$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
194# Libraries not available for DOS
195$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000196endif
Ollie Lho184a4042005-11-26 21:55:36 +0000197
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000198# FIXME: Should we check for Cygwin/MSVC as well?
199ifeq ($(TARGET_OS), MinGW)
200EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000201# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000202FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000203# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000204# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000205FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100206
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000207# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200208$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
209# And programmers that need raw access.
210$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000211
Nico Huberca621782021-06-27 13:53:49 +0200212else # No MinGW
213
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100214# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200215$(call mark_unsupported,CONFIG_NI845X_SPI)
216
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100217endif
218
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000219ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000220ifeq ($(MAKECMDGOALS),)
221.DEFAULT_GOAL := libflashrom.a
222$(info Setting default goal to libflashrom.a)
223endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000224FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200225$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000226# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200227$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000228# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200229$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100230# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200231$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000232endif
233
Nico Huberdc8e54a2021-06-27 14:17:34 +0200234# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
235ifeq ($(filter $(TARGET_OS),Linux Android), )
236$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
237$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000238endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000239
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000240ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200241# Android on x86 (currently) does not provide raw PCI port I/O operations.
242$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000243endif
244
Stefan Tauner037cd842013-08-25 00:10:56 +0000245###############################################################################
246# General architecture-specific settings.
247# Like above for the OS, below we verify user-supplied options depending on the target architecture.
248
Uwe Hermann44ffd582011-08-20 14:16:00 +0000249# Determine the destination processor architecture.
250# IMPORTANT: The following line must be placed before ARCH is ever used
251# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000252# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900253override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
254 | tail -1 | cut -f 2 -d'"'))
255override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
256 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000257
Nico Huberc8801732017-12-01 18:19:43 +0000258# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
259ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200260$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000261endif
262
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000263# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000264# Right now this means the drivers below only work on x86.
265ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200266$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
267$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
268$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000269endif
270
Nico Huber8945b812021-06-27 14:24:53 +0200271# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
272# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000273# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700274ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200275$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
276$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
277$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000278endif
279
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000280###############################################################################
281# Flash chip drivers and bus support infrastructure.
282
Stefan Tauner4404f732013-09-12 08:28:56 +0000283CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000284 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300285 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100286 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
287 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000288
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000289###############################################################################
290# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000291
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200292LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000293
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000294###############################################################################
295# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000296
Stefan Tauner9b32de92014-08-08 23:52:33 +0000297CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000298
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200299# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
300# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
301# be obtained using util/getrevision.sh, which is the common case during development.
302-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200303VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200304MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000305
Stefan Tauner76347082016-11-27 17:45:49 +0100306SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000307
Stefan Tauner76347082016-11-27 17:45:49 +0100308# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100309ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100310$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100311endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000312
Stefan Tauner037cd842013-08-25 00:10:56 +0000313###############################################################################
314# Default settings of CONFIG_* variables.
315
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000316# Always enable internal/onboard support for now.
317CONFIG_INTERNAL ?= yes
318
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000319# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000320CONFIG_SERPROG ?= yes
321
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000322# RayeR SPIPGM hardware support
323CONFIG_RAYER_SPI ?= yes
324
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000325# PonyProg2000 SPI hardware support
326CONFIG_PONY_SPI ?= yes
327
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000328# Always enable 3Com NICs for now.
329CONFIG_NIC3COM ?= yes
330
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000331# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
332CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000333
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000334# Always enable SiI SATA controllers for now.
335CONFIG_SATASII ?= yes
336
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000337# Highpoint (HPT) ATA/RAID controller support.
338# IMPORTANT: This code is not yet working!
339CONFIG_ATAHPT ?= no
340
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000341# VIA VT6421A LPC memory support
342CONFIG_ATAVIA ?= yes
343
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000344# Promise ATA controller support.
345CONFIG_ATAPROMISE ?= no
346
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000347# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000348CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000349
James Lairdc60de0e2013-03-27 13:00:23 +0000350# Always enable Altera USB-Blaster dongles for now.
351CONFIG_USBBLASTER_SPI ?= yes
352
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000353# MSTAR DDC support needs more tests/reviews/cleanups.
354CONFIG_MSTARDDC_SPI ?= no
355
Justin Chevrier66e554b2015-02-08 21:58:10 +0000356# Always enable PICkit2 SPI dongles for now.
357CONFIG_PICKIT2_SPI ?= yes
358
Miklós Márton324929c2019-08-01 19:14:10 +0200359# Always enable STLink V3
360CONFIG_STLINKV3_SPI ?= yes
361
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000362# Always enable dummy tracing for now.
363CONFIG_DUMMY ?= yes
364
365# Always enable Dr. Kaiser for now.
366CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000367
Joerg Fischer5665ef32010-05-21 21:54:07 +0000368# Always enable Realtek NICs for now.
369CONFIG_NICREALTEK ?= yes
370
Andrew Morganc29c2e72010-06-07 22:37:54 +0000371# Disable National Semiconductor NICs until support is complete and tested.
372CONFIG_NICNATSEMI ?= no
373
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000374# Always enable Intel NICs for now.
375CONFIG_NICINTEL ?= yes
376
Idwer Vollering004f4b72010-09-03 18:21:21 +0000377# Always enable SPI on Intel NICs for now.
378CONFIG_NICINTEL_SPI ?= yes
379
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000380# Always enable EEPROM on Intel NICs for now.
381CONFIG_NICINTEL_EEPROM ?= yes
382
Mark Marshall90021f22010-12-03 14:48:11 +0000383# Always enable SPI on OGP cards for now.
384CONFIG_OGP_SPI ?= yes
385
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000386# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000387CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000388
Simon Glassae616512016-01-23 23:27:58 +0000389# Always enable Dediprog SF100 for now.
390CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000391
Daniel Thompson45e91a22018-06-04 13:46:29 +0100392# Always enable Developerbox emergency recovery for now.
393CONFIG_DEVELOPERBOX_SPI ?= yes
394
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000395# Always enable Marvell SATA controllers for now.
396CONFIG_SATAMV ?= yes
397
David Hendricksf9a30552015-05-23 20:30:30 -0700398# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
399CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000400CONFIG_LINUX_SPI ?= yes
401
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000402# Always enable ITE IT8212F PATA controllers for now.
403CONFIG_IT8212 ?= yes
404
Urja Rannikko0870b022016-01-31 22:10:29 +0000405# Winchiphead CH341A
406CONFIG_CH341A_SPI ?= yes
407
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100408# Digilent Development board JTAG
409CONFIG_DIGILENT_SPI ?= yes
410
Jean THOMASe28d8e42022-10-11 17:54:30 +0200411# DirtyJTAG
412CONFIG_DIRTYJTAG_SPI ?= yes
413
Marc Schink3578ec62016-03-17 16:23:03 +0100414# Disable J-Link for now.
415CONFIG_JLINK_SPI ?= no
416
Nico Huber83d52072021-06-27 00:07:13 +0200417# National Instruments USB-845x is Windows only and needs a proprietary library.
418CONFIG_NI845X_SPI ?= no
419
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000420# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000421CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000422
Stefan Taunerf3503372016-02-26 23:51:21 +0000423# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
424ifeq ($(CONFIG_NOTHING), yes)
425 ifeq ($(CONFIG_EVERYTHING), yes)
426 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
427 endif
428 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
429 $(if $(filter yes, $($(var))),\
430 $(eval $(var)=no)))
431endif
432
Patrick Georgiced7ab62015-01-19 19:52:34 +0000433# Enable all features if CONFIG_EVERYTHING=yes is given
434ifeq ($(CONFIG_EVERYTHING), yes)
435$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
436 $(if $(filter no, $($(var))),\
437 $(eval $(var)=yes)))
438endif
439
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000440# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200441
442ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200443override CONFIG_BITBANG_SPI = yes
444else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000445CONFIG_BITBANG_SPI ?= no
446endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000447
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000448###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000449# Handle CONFIG_* variables that depend on others set (and verified) above.
450
451# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
452ifeq ($(TARGET_OS), libpayload)
453ifeq ($(CONFIG_INTERNAL), yes)
454ifeq ($(CONFIG_INTERNAL_DMI), no)
455UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
456else
457override CONFIG_INTERNAL_DMI = yes
458endif
459endif
460endif
461
462# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
463CONFIG_INTERNAL_DMI ?= yes
464
465###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000466# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000467# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000468
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200469ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
470FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
471else
472FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
473endif
474
Stefan Tauner265fcac2014-06-02 00:12:23 +0000475FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000476
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000477ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000478FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000479PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000480ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000481PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200482PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000483ifeq ($(CONFIG_INTERNAL_DMI), yes)
484FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
485endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000486else
487endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000488endif
489
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000490ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000491FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000492PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000493NEED_SERIAL += CONFIG_SERPROG
494NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000495endif
496
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000497ifeq ($(CONFIG_RAYER_SPI), yes)
498FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
499PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000500NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000501endif
502
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000503ifeq ($(CONFIG_PONY_SPI), yes)
504FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
505PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000506NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000507endif
508
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000509ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000510FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000511PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000512endif
513
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000514ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000515FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000516PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000517endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000518
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000519ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000520FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000521PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000522endif
523
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000524ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000525FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000526PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000527endif
528
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000529ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000530FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000531PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000532endif
533
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000534ifeq ($(CONFIG_ATAVIA), yes)
535FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
536PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000537endif
538
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000539ifeq ($(CONFIG_ATAPROMISE), yes)
540FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
541PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000542endif
543
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000544ifeq ($(CONFIG_IT8212), yes)
545FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
546PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000547endif
548
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000549ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000550# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000551FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000552PROGRAMMER_OBJS += ft2232_spi.o
553endif
554
555ifeq ($(CONFIG_USBBLASTER_SPI), yes)
556# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000557FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000558PROGRAMMER_OBJS += usbblaster_spi.o
559endif
560
Justin Chevrier66e554b2015-02-08 21:58:10 +0000561ifeq ($(CONFIG_PICKIT2_SPI), yes)
562FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
563PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000564endif
565
Miklós Márton324929c2019-08-01 19:14:10 +0200566ifeq ($(CONFIG_STLINKV3_SPI), yes)
567FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
568PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200569endif
570
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000571ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000572FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000573PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000574endif
575
576ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000577FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000578PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000579endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000580
Joerg Fischer5665ef32010-05-21 21:54:07 +0000581ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000582FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000583PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000584endif
585
Andrew Morganc29c2e72010-06-07 22:37:54 +0000586ifeq ($(CONFIG_NICNATSEMI), yes)
587FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
588PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000589endif
590
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000591ifeq ($(CONFIG_NICINTEL), yes)
592FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
593PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000594endif
595
Idwer Vollering004f4b72010-09-03 18:21:21 +0000596ifeq ($(CONFIG_NICINTEL_SPI), yes)
597FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
598PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000599endif
600
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000601ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
602FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
603PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000604endif
605
Mark Marshall90021f22010-12-03 14:48:11 +0000606ifeq ($(CONFIG_OGP_SPI), yes)
607FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
608PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000609endif
610
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000611ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
612FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000613PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000614NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000615endif
616
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000617ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000618FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000619PROGRAMMER_OBJS += dediprog.o
620endif
621
Daniel Thompson45e91a22018-06-04 13:46:29 +0100622ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
623FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
624PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100625endif
626
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000627ifeq ($(CONFIG_SATAMV), yes)
628FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
629PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000630endif
631
David Hendricksf9a30552015-05-23 20:30:30 -0700632ifeq ($(CONFIG_LINUX_MTD), yes)
633# This is a totally ugly hack.
634FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
635PROGRAMMER_OBJS += linux_mtd.o
636endif
637
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000638ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000639# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000640FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000641PROGRAMMER_OBJS += linux_spi.o
642endif
643
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000644ifeq ($(CONFIG_MSTARDDC_SPI), yes)
645# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000646FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000647NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000648PROGRAMMER_OBJS += mstarddc_spi.o
649endif
650
Urja Rannikko0870b022016-01-31 22:10:29 +0000651ifeq ($(CONFIG_CH341A_SPI), yes)
652FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
653PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000654endif
655
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100656ifeq ($(CONFIG_DIGILENT_SPI), yes)
657FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
658PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100659endif
660
Jean THOMASe28d8e42022-10-11 17:54:30 +0200661ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
662FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
663PROGRAMMER_OBJS += dirtyjtag_spi.o
664endif
665
Marc Schink3578ec62016-03-17 16:23:03 +0100666ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100667FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
668PROGRAMMER_OBJS += jlink_spi.o
669endif
670
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100671ifeq ($(CONFIG_NI845X_SPI), yes)
672FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
673
674ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
675# if the user did not specified the NI-845x headers/lib path
676# do a guess for both 32 and 64 bit Windows versions
677NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100678NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200679
680# hack to access env variable containing brackets...
681PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
682
683ifneq ($(PROGRAMFILES_X86DIR),)
684ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
685NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
686NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
687endif
688endif
689
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100690else
691NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
692NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
693endif
694
695FEATURE_CFLAGS += $(NI845X_INCLUDES)
696LIBS += -lni845x
697PROGRAMMER_OBJS += ni845x_spi.o
698endif
699
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000700ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200701LIB_OBJS += serial.o
702ifeq ($(TARGET_OS), Linux)
703LIB_OBJS += custom_baud_linux.o
704else
705LIB_OBJS += custom_baud.o
706endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000707endif
708
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000709ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000710ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000711LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000712endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000713endif
714
Nico Huberf55ca202021-06-27 14:36:06 +0200715NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000716ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000717CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000718# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
719# libpci may need raw memory, MSR or PCI port I/O on some platforms.
720# Individual drivers might have the same needs as well.
721NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000722FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000723FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000724
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000725PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000726ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000727# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000728PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000729else
730PCILIBS += -lpci
731endif
732endif
733
734ifneq ($(NEED_RAW_ACCESS), )
735# Raw memory, MSR or PCI port I/O access.
736FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
737PROGRAMMER_OBJS += physmap.o hwaccess.o
738
739ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200740ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000741PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200742endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000743else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000744ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200745ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000746PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200747endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000748else
749ifeq ($(TARGET_OS), Darwin)
750# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000751PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000752endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000753endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000754endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000755
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000756endif
757
Nico Huberf55ca202021-06-27 14:36:06 +0200758NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000759ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000760CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100761PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000762# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
763ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
764USB1LIBS += -lusb
765else
766ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000767override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000768USB1LIBS += -lusb-1.0
769else
Stefan Tauner45207062016-02-19 08:17:24 +0000770USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
771override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000772endif
773endif
774endif
775
Nico Huberf55ca202021-06-27 14:36:06 +0200776NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200777ifneq ($(NEED_LIBFTDI), )
778FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
779FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
780FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
781FEATURE_CFLAGS += $(FTDI_INCLUDES)
782FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
783# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
784# into a hard requirement for libusb, defeating the purpose of auto-enabling.
785endif
786
Nico Huberf55ca202021-06-27 14:36:06 +0200787NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100788ifneq ($(NEED_LIBJAYLINK), )
789CHECK_LIBJAYLINK = yes
790JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
791override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
792endif
793
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000794ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000795FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000796CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000797endif
798
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000799FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000800
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000801# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000802FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000803
Nico Huber8624e8c2012-11-05 21:46:33 +0100804FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
805FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
806
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000807LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000808OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000809
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000810all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000811ifeq ($(ARCH), x86)
812 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
813endif
814
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000815$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100816 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000817
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000818libflashrom.a: $(LIBFLASHROM_OBJS)
819 $(AR) rcs $@ $^
820 $(RANLIB) $@
821
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000822# TAROPTIONS reduces information leakage from the packager's system.
823# If other tar programs support command line arguments for setting uid/gid of
824# stored files, they can be handled here as well.
825TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000826
Paul Fox05dfbe62009-06-16 21:08:06 +0000827%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100828 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000829
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000830# Make sure to add all names of generated binaries here.
831# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000832# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000833clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000834 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000835 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000836
Ollie Lho184a4042005-11-26 21:55:36 +0000837distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000838 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000839
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000840strip: $(PROGRAM)$(EXEC_SUFFIX)
841 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000842
Stefan Tauner56787082011-08-18 02:27:19 +0000843# to define test programs we use verbatim variables, which get exported
844# to environment variables and are referenced with $$<varname> later
845
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000846compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000847 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000848 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000849 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000850 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
851 echo "found." || { echo "not found."; \
852 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000853 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000854 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000855 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000856 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900857 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000858 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000859 @printf "Target OS is "
860 @# FreeBSD wc will output extraneous whitespace.
861 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900862 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000863 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000864ifeq ($(TARGET_OS), libpayload)
865 @$(CC) --version 2>&1 | grep -q coreboot || \
866 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
867 echo "This might work but usually does not, please beware." )
868endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000869
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000870hwlibs: compiler
871 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000872ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000873 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000874 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000875 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000876 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
877 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000878 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000879 echo "Please install libpci headers or disable all features"; \
880 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000881 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000882 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
883 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000884 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000885 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000887 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000888 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
889 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000890 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000891 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
892 echo "yes." || { echo "no."; \
893 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000894 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
895 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000896 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000897 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000898 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
899 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000900 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000901 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000902 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000903endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000904ifeq ($(CHECK_LIBUSB1), yes)
905 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
906 @echo "$$LIBUSB1_TEST" > .test.c
907 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
908 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
909 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000910 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000911 echo "Please install libusb-1.0 headers or disable all features"; \
912 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000913 echo "See README for more information."; echo; \
914 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
915 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
916 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
917 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
918 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000919 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000920 echo "Please install libusb-1.0 or disable all features"; \
921 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000922 echo "See README for more information."; echo; \
923 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
924 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
925endif
Marc Schink3578ec62016-03-17 16:23:03 +0100926ifeq ($(CHECK_LIBJAYLINK), yes)
927 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
928 @echo "$$LIBJAYLINK_TEST" > .test.c
929 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
930 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
931 echo "found." || { echo "not found."; echo; \
932 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
933 echo "Please install libjaylink headers or disable the feature"; \
934 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
935 echo "See README for more information."; echo; \
936 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
937 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
938 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
939 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
940 echo "yes." || { echo "no."; \
941 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
942 echo "Please install libjaylink or disable the feature"; \
943 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
944 echo "See README for more information."; echo; \
945 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
946 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
947endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000948
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000949.features: features
950
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000951# If a user does not explicitly request a non-working feature, we should
952# silently disable it. However, if a non-working (does not compile) feature
953# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000954# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000955featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000956ifeq ($(PROGRAMMER_OBJS),)
957 @echo "You have to enable at least one programmer driver!"
958 @false
959endif
960ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000961 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
962 @false
963endif
964
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000965features: compiler
966 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000967ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000968 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000969 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000970 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000971 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
972 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
973 printf "Checking for FT232H support in libftdi... " ; \
974 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000975 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000976 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
977 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
978 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
979 ) || \
980 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
981 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000982endif
David Hendricksf9a30552015-05-23 20:30:30 -0700983ifeq ($(CONFIG_LINUX_MTD), yes)
984 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
985 @echo "$$LINUX_MTD_TEST" > .featuretest.c
986 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
987 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
988 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
989 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
990 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
991endif
Stefan Tauner8868db32012-03-13 00:18:19 +0000992ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000993 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +0000994 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000995 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000996 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +0000997 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000998 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
999 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001000endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001001ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001002 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001003 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001004 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001005 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001006 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001007 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1008 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001009endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001010ifeq ($(CONFIG_NI845X_SPI), yes)
1011 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1012 @echo "$$NI845X_TEST" > .featuretest.c
1013 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1014
1015 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1016 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1017 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1018 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1019 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1020 echo "For the NI-845x 17.0 the library path is:"; \
1021 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1022 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1023 exit 1; }; } \
1024 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1025endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001026 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001027 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001028 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001029 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001030 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001031 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001032 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001033ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1034 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1035 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1036else
Nico Huber8624e8c2012-11-05 21:46:33 +01001037 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1038 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1039 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1040 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1041 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1042 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001043endif
Stefan Tauner56787082011-08-18 02:27:19 +00001044 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1045 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001046
Stefan Tauner4c723152016-01-14 22:47:55 +00001047$(PROGRAM).8.html: $(PROGRAM).8
1048 @groff -mandoc -Thtml $< >$@
1049
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001050$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001051 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001052 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001053
1054install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001055 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001056 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001057 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001058 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001059
Nico Huber454f6132012-12-10 13:34:10 +00001060libinstall: libflashrom.a libflashrom.h
1061 mkdir -p $(DESTDIR)$(PREFIX)/lib
1062 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1063 mkdir -p $(DESTDIR)$(PREFIX)/include
1064 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1065
Nico Huber5f245a22023-01-10 17:14:47 +01001066versioninfo:
1067# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1068 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1069 @echo "VERSION = $(RELEASE)" > $@.inc
1070 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1071
Nico Huber26c2c4d2023-01-10 17:45:38 +01001072branch: versioninfo
1073 @git checkout -b $(RELEASE)
1074 @git add -f $<.inc
1075 @git commit -sm'Update version info for $(RELEASE)'
1076
1077tag: versioninfo
1078 @git add -f $<.inc
1079 @git commit -sm'Update version info for $(RELEASE)'
1080 @git tag -s $(RELEASE)
1081
Nico Huber5f245a22023-01-10 17:14:47 +01001082# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001083RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001084
Nico Huber1d58a902023-01-10 18:26:12 +01001085_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001086_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001087 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1088 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1089 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001090# Generate fresh versioninfo.inc and compare
1091 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1092 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1093 "$(EXPORT_VERSIONINFO)"
1094 @if [ -f versioninfo.inc ]; then \
1095 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1096 { echo Error: Version info changed:; \
1097 cat "$(EXPORT_VERSIONINFO)"; \
1098 echo Update versioninfo.inc and tag accordingly.; \
1099 exit 1; \
1100 }; \
1101 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001102# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1103# sed is required to filter out file names having the attribute set.
1104# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1105# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001106 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1107 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001108 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001109 xargs -0 sh -c 'for f; do \
1110 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001111 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001112 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001113
Stefan Tauner76347082016-11-27 17:45:49 +01001114export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001115 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001116
1117tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001118 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1119 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001120# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001121 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1122 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001123
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001124libpayload: clean
1125 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001126
Felix Singer9441c6e2022-10-21 12:47:11 +02001127gitconfig:
1128 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1129
Nico Huber26c2c4d2023-01-10 17:45:38 +01001130.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001131
Stefan Tauner23e10b82016-01-23 16:16:49 +00001132# Disable implicit suffixes and built-in rules (for performance and profit)
1133.SUFFIXES:
1134
Stefan Reinauere2f01582010-06-07 11:08:07 +00001135-include $(OBJS:.o=.d)